class RK4
{
   static var currentaccel;
   static var returnObj;
   function RK4()
   {
   }
   static function RK4acceleration(state, dir)
   {
      var _loc1_ = RK4.currentaccel;
      return _loc1_;
   }
   static function RK4evaluate(initial, dt, d, dir)
   {
      var _loc1_ = new Object();
      if(d.dx != undefined)
      {
         _loc1_.x = initial.x + d.dx * dt;
         _loc1_.v = initial.v + d.dv * dt;
      }
      else
      {
         _loc1_.x = initial.x;
         _loc1_.v = initial.v;
      }
      var _loc2_ = new Object();
      if(d.dx != undefined)
      {
         _loc2_.dx = _loc1_.v;
         _loc2_.dv = RK4.RK4acceleration(_loc1_,dir);
      }
      else
      {
         _loc2_.dx = _loc1_.v;
         _loc2_.dv = RK4.RK4acceleration(_loc1_,dir);
      }
      return _loc2_;
   }
   static function RK4Integrate(state, dt, dir)
   {
      var _loc4_ = RK4.RK4evaluate(state,0,dir);
      var _loc3_ = RK4.RK4evaluate(state,dt * 0.5,_loc4_,dir);
      var _loc2_ = RK4.RK4evaluate(state,dt * 0.5,_loc3_,dir);
      var _loc7_ = RK4.RK4evaluate(state,dt,_loc2_,dir);
      var _loc9_ = 0.16666666666666666 * (_loc4_.dx + 2 * (_loc3_.dx + _loc2_.dx) + _loc7_.dx);
      var _loc8_ = 0.16666666666666666 * (_loc4_.dv + 2 * (_loc3_.dv + _loc2_.dv) + _loc7_.dv);
      state.x += _loc9_ * dt;
      state.v += _loc8_ * dt * dir;
      return state;
   }
   static function calc(tx, tv, ca)
   {
      RK4.returnObj = new Object();
      RK4.currentaccel = ca;
      var _loc2_ = new Object();
      _loc2_.x = tx;
      _loc2_.v = tv;
      RK4.returnObj = RK4.RK4Integrate(_loc2_,_global.interval,1);
      return RK4.returnObj;
   }
}
